]> git.ipfire.org Git - thirdparty/git.git/blame - git-filter-branch.sh
Git 2.0.1
[thirdparty/git.git] / git-filter-branch.sh
CommitLineData
6f6826c5
JS
1#!/bin/sh
2#
3# Rewrite revision history
4# Copyright (c) Petr Baudis, 2006
5# Minimal changes to "port" it to core-git (c) Johannes Schindelin, 2007
6#
c401b33c
JS
7# Lets you rewrite the revision history of the current branch, creating
8# a new branch. You can specify a number of filters to modify the commits,
9# files and trees.
6f6826c5 10
16ed34ad
JS
11# The following functions will also be available in the commit filter:
12
13functions=$(cat << \EOF
b5669a05 14warn () {
285c6cbf 15 echo "$*" >&2
b5669a05
SP
16}
17
6f6826c5
JS
18map()
19{
3520e1e8 20 # if it was not rewritten, take the original
c57a3494
JS
21 if test -r "$workdir/../map/$1"
22 then
23 cat "$workdir/../map/$1"
24 else
25 echo "$1"
26 fi
6f6826c5
JS
27}
28
f95eef15
JS
29# if you run 'skip_commit "$@"' in a commit filter, it will print
30# the (mapped) parents, effectively skipping the commit.
31
32skip_commit()
33{
34 shift;
35 while [ -n "$1" ];
36 do
37 shift;
38 map "$1";
39 shift;
40 done;
41}
42
d3240d93
PH
43# if you run 'git_commit_non_empty_tree "$@"' in a commit filter,
44# it will skip commits that leave the tree untouched, commit the other.
45git_commit_non_empty_tree()
46{
47 if test $# = 3 && test "$1" = $(git rev-parse "$3^{tree}"); then
48 map "$3"
49 else
50 git commit-tree "$@"
51 fi
52}
8c1ce0f4
JS
53# override die(): this version puts in an extra line break, so that
54# the progress is still visible
55
56die()
57{
58 echo >&2
59 echo "$*" >&2
60 exit 1
61}
16ed34ad
JS
62EOF
63)
64
65eval "$functions"
8c1ce0f4 66
3c730fab
JK
67finish_ident() {
68 # Ensure non-empty id name.
69 echo "case \"\$GIT_$1_NAME\" in \"\") GIT_$1_NAME=\"\${GIT_$1_EMAIL%%@*}\" && export GIT_$1_NAME;; esac"
70 # And make sure everything is exported.
71 echo "export GIT_$1_NAME"
72 echo "export GIT_$1_EMAIL"
73 echo "export GIT_$1_DATE"
74}
6f6826c5
JS
75
76set_ident () {
3c730fab
JK
77 parse_ident_from_commit author AUTHOR committer COMMITTER
78 finish_ident AUTHOR
79 finish_ident COMMITTER
6f6826c5
JS
80}
81
83e355a6 82USAGE="[--env-filter <command>] [--tree-filter <command>]
9dcca58d
JH
83 [--index-filter <command>] [--parent-filter <command>]
84 [--msg-filter <command>] [--commit-filter <command>]
85 [--tag-name-filter <command>] [--subdirectory-filter <directory>]
86 [--original <namespace>] [-d <directory>] [-f | --force]
87 [<rev-list options>...]"
7e0f1704 88
8f321a39 89OPTIONS_SPEC=
7e0f1704
JS
90. git-sh-setup
91
a4661b01 92if [ "$(is_bare_repository)" = false ]; then
5347a50f 93 require_clean_work_tree 'rewrite branches'
a4661b01 94fi
46eb449c 95
6f6826c5 96tempdir=.git-rewrite
6f6826c5
JS
97filter_env=
98filter_tree=
99filter_index=
100filter_parent=
101filter_msg=cat
d3240d93 102filter_commit=
6f6826c5 103filter_tag_name=
685ef546 104filter_subdir=
dfd05e38
JS
105orig_namespace=refs/original/
106force=
d3240d93 107prune_empty=
f2f3a6b8 108remap_to_ancestor=
822f7c73 109while :
6f6826c5
JS
110do
111 case "$1" in
112 --)
113 shift
114 break
115 ;;
dfd05e38
JS
116 --force|-f)
117 shift
118 force=t
119 continue
120 ;;
f2f3a6b8 121 --remap-to-ancestor)
7ec344d8 122 # deprecated ($remap_to_ancestor is set now automatically)
f2f3a6b8
TR
123 shift
124 remap_to_ancestor=t
125 continue
126 ;;
d3240d93
PH
127 --prune-empty)
128 shift
129 prune_empty=t
130 continue
131 ;;
6f6826c5
JS
132 -*)
133 ;;
134 *)
135 break;
136 esac
137
138 # all switches take one argument
139 ARG="$1"
140 case "$#" in 1) usage ;; esac
141 shift
142 OPTARG="$1"
143 shift
144
145 case "$ARG" in
146 -d)
147 tempdir="$OPTARG"
148 ;;
6f6826c5
JS
149 --env-filter)
150 filter_env="$OPTARG"
151 ;;
152 --tree-filter)
153 filter_tree="$OPTARG"
154 ;;
155 --index-filter)
156 filter_index="$OPTARG"
157 ;;
158 --parent-filter)
159 filter_parent="$OPTARG"
160 ;;
161 --msg-filter)
162 filter_msg="$OPTARG"
163 ;;
164 --commit-filter)
16ed34ad 165 filter_commit="$functions; $OPTARG"
6f6826c5
JS
166 ;;
167 --tag-name-filter)
168 filter_tag_name="$OPTARG"
169 ;;
685ef546
JS
170 --subdirectory-filter)
171 filter_subdir="$OPTARG"
f2f3a6b8 172 remap_to_ancestor=t
685ef546 173 ;;
dfd05e38 174 --original)
55ced83d 175 orig_namespace=$(expr "$OPTARG/" : '\(.*[^/]\)/*$')/
dfd05e38 176 ;;
6f6826c5
JS
177 *)
178 usage
179 ;;
180 esac
181done
182
d3240d93
PH
183case "$prune_empty,$filter_commit" in
184,)
185 filter_commit='git commit-tree "$@"';;
186t,)
187 filter_commit="$functions;"' git_commit_non_empty_tree "$@"';;
188,*)
189 ;;
190*)
5da81713 191 die "Cannot set --prune-empty and --commit-filter at the same time"
d3240d93
PH
192esac
193
dfd05e38
JS
194case "$force" in
195t)
196 rm -rf "$tempdir"
197;;
198'')
199 test -d "$tempdir" &&
200 die "$tempdir already exists, please remove it"
201esac
97276019 202orig_dir=$(pwd)
af580e9c 203mkdir -p "$tempdir/t" &&
dfd05e38 204tempdir="$(cd "$tempdir"; pwd)" &&
af580e9c
JS
205cd "$tempdir/t" &&
206workdir="$(pwd)" ||
207die ""
6f6826c5 208
def16e71 209# Remove tempdir on exit
97276019 210trap 'cd "$orig_dir"; rm -rf "$tempdir"' 0
def16e71 211
88e38808
LN
212ORIG_GIT_DIR="$GIT_DIR"
213ORIG_GIT_WORK_TREE="$GIT_WORK_TREE"
214ORIG_GIT_INDEX_FILE="$GIT_INDEX_FILE"
215GIT_WORK_TREE=.
216export GIT_DIR GIT_WORK_TREE
217
dfd05e38 218# Make sure refs/original is empty
0ea29cce 219git for-each-ref > "$tempdir"/backup-refs || exit
dfd05e38
JS
220while read sha1 type name
221do
222 case "$force,$name" in
223 ,$orig_namespace*)
734cd572
JT
224 die "Cannot create a new backup.
225A previous backup already exists in $orig_namespace
226Force overwriting the backup with -f"
dfd05e38
JS
227 ;;
228 t,$orig_namespace*)
229 git update-ref -d "$name" $sha1
230 ;;
231 esac
232done < "$tempdir"/backup-refs
233
418fa3a5 234# The refs should be updated if their heads were rewritten
0ea29cce
EK
235git rev-parse --no-flags --revs-only --symbolic-full-name \
236 --default HEAD "$@" > "$tempdir"/raw-heads || exit
237sed -e '/^^/d' "$tempdir"/raw-heads >"$tempdir"/heads
dfd05e38
JS
238
239test -s "$tempdir"/heads ||
240 die "Which ref do you want to rewrite?"
241
3addc94a
JS
242GIT_INDEX_FILE="$(pwd)/../index"
243export GIT_INDEX_FILE
6f6826c5 244
af580e9c
JS
245# map old->new commit ids for rewriting parents
246mkdir ../map || die "Could not create map/ directory"
6f6826c5 247
2c1d2d81
TR
248# we need "--" only if there are no path arguments in $@
249nonrevs=$(git rev-parse --no-revs "$@") || exit
7ec344d8
CH
250if test -z "$nonrevs"
251then
252 dashdash=--
253else
254 dashdash=
255 remap_to_ancestor=t
256fi
257
3361a548 258git rev-parse --revs-only "$@" >../parse
2c1d2d81 259
685ef546
JS
260case "$filter_subdir" in
261"")
2c1d2d81 262 eval set -- "$(git rev-parse --sq --no-revs "$@")"
685ef546
JS
263 ;;
264*)
2c1d2d81
TR
265 eval set -- "$(git rev-parse --sq --no-revs "$@" $dashdash \
266 "$filter_subdir")"
267 ;;
268esac
269
270git rev-list --reverse --topo-order --default HEAD \
3361a548 271 --parents --simplify-merges --stdin "$@" <../parse >../revs ||
2c1d2d81 272 die "Could not get the commits"
9d6f220c 273commits=$(wc -l <../revs | tr -d " ")
6f6826c5
JS
274
275test $commits -eq 0 && die "Found nothing to rewrite"
276
dfd05e38
JS
277# Rewrite the commits
278
d5b0c97d 279git_filter_branch__commit_count=0
813b4734 280while read commit parents; do
d5b0c97d
EN
281 git_filter_branch__commit_count=$(($git_filter_branch__commit_count+1))
282 printf "\rRewrite $commit ($git_filter_branch__commit_count/$commits)"
6f6826c5 283
685ef546
JS
284 case "$filter_subdir" in
285 "")
83bd7437 286 GIT_ALLOW_NULL_SHA1=1 git read-tree -i -m $commit
685ef546
JS
287 ;;
288 *)
5b044ac3 289 # The commit may not have the subdirectory at all
83bd7437
JK
290 err=$(GIT_ALLOW_NULL_SHA1=1 \
291 git read-tree -i -m $commit:"$filter_subdir" 2>&1) || {
d69da76d 292 if ! git rev-parse -q --verify $commit:"$filter_subdir"
5b044ac3
JH
293 then
294 rm -f "$GIT_INDEX_FILE"
295 else
296 echo >&2 "$err"
297 false
298 fi
299 }
af580e9c 300 esac || die "Could not initialize the index"
6f6826c5 301
3addc94a
JS
302 GIT_COMMIT=$commit
303 export GIT_COMMIT
af580e9c
JS
304 git cat-file commit "$commit" >../commit ||
305 die "Cannot read commit $commit"
6f6826c5 306
3c730fab
JK
307 eval "$(set_ident <../commit)" ||
308 die "setting author/committer failed for commit $commit"
8c1ce0f4
JS
309 eval "$filter_env" < /dev/null ||
310 die "env filter failed: $filter_env"
6f6826c5
JS
311
312 if [ "$filter_tree" ]; then
af580e9c
JS
313 git checkout-index -f -u -a ||
314 die "Could not checkout the index"
6f6826c5
JS
315 # files that $commit removed are now still in the working tree;
316 # remove them, else they would be added again
6a589fda 317 git clean -d -q -f -x
8c1ce0f4
JS
318 eval "$filter_tree" < /dev/null ||
319 die "tree filter failed: $filter_tree"
320
1fe32cb9 321 (
03ca8395 322 git diff-index -r --name-only --ignore-submodules $commit &&
1fe32cb9 323 git ls-files --others
0ea29cce
EK
324 ) > "$tempdir"/tree-state || exit
325 git update-index --add --replace --remove --stdin \
326 < "$tempdir"/tree-state || exit
6f6826c5
JS
327 fi
328
8c1ce0f4
JS
329 eval "$filter_index" < /dev/null ||
330 die "index filter failed: $filter_index"
6f6826c5
JS
331
332 parentstr=
813b4734 333 for parent in $parents; do
3520e1e8
JS
334 for reparent in $(map "$parent"); do
335 parentstr="$parentstr -p $reparent"
336 done
6f6826c5
JS
337 done
338 if [ "$filter_parent" ]; then
8c1ce0f4
JS
339 parentstr="$(echo "$parentstr" | eval "$filter_parent")" ||
340 die "parent filter failed: $filter_parent"
6f6826c5
JS
341 fi
342
343 sed -e '1,/^$/d' <../commit | \
8c1ce0f4
JS
344 eval "$filter_msg" > ../message ||
345 die "msg filter failed: $filter_msg"
0906f6e1 346 workdir=$workdir @SHELL_PATH@ -c "$filter_commit" "git commit-tree" \
0ea29cce
EK
347 $(git write-tree) $parentstr < ../message > ../map/$commit ||
348 die "could not write rewritten commit"
6f6826c5
JS
349done <../revs
350
f2f3a6b8
TR
351# If we are filtering for paths, as in the case of a subdirectory
352# filter, it is possible that a specified head is not in the set of
353# rewritten commits, because it was pruned by the revision walker.
354# Ancestor remapping fixes this by mapping these heads to the unique
355# nearest ancestor that survived the pruning.
dfd05e38 356
f2f3a6b8 357if test "$remap_to_ancestor" = t
a0e46390
TR
358then
359 while read ref
dfd05e38 360 do
a0e46390
TR
361 sha1=$(git rev-parse "$ref"^0)
362 test -f "$workdir"/../map/$sha1 && continue
2c1d2d81 363 ancestor=$(git rev-list --simplify-merges -1 "$ref" "$@")
a0e46390
TR
364 test "$ancestor" && echo $(map $ancestor) >> "$workdir"/../map/$sha1
365 done < "$tempdir"/heads
366fi
dfd05e38
JS
367
368# Finally update the refs
369
370_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
371_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
dfd05e38
JS
372echo
373while read ref
374do
375 # avoid rewriting a ref twice
376 test -f "$orig_namespace$ref" && continue
377
378 sha1=$(git rev-parse "$ref"^0)
379 rewritten=$(map $sha1)
380
381 test $sha1 = "$rewritten" &&
382 warn "WARNING: Ref '$ref' is unchanged" &&
383 continue
384
385 case "$rewritten" in
386 '')
387 echo "Ref '$ref' was deleted"
388 git update-ref -m "filter-branch: delete" -d "$ref" $sha1 ||
389 die "Could not delete $ref"
98409060 390 ;;
dfd05e38
JS
391 $_x40)
392 echo "Ref '$ref' was rewritten"
261044e8
TR
393 if ! git update-ref -m "filter-branch: rewrite" \
394 "$ref" $rewritten $sha1 2>/dev/null; then
395 if test $(git cat-file -t "$ref") = tag; then
396 if test -z "$filter_tag_name"; then
397 warn "WARNING: You said to rewrite tagged commits, but not the corresponding tag."
398 warn "WARNING: Perhaps use '--tag-name-filter cat' to rewrite the tag."
399 fi
400 else
401 die "Could not rewrite $ref"
402 fi
403 fi
98409060 404 ;;
dfd05e38
JS
405 *)
406 # NEEDSWORK: possibly add -Werror, making this an error
407 warn "WARNING: '$ref' was rewritten into multiple commits:"
408 warn "$rewritten"
409 warn "WARNING: Ref '$ref' points to the first one now."
410 rewritten=$(echo "$rewritten" | head -n 1)
411 git update-ref -m "filter-branch: rewrite to first" \
412 "$ref" $rewritten $sha1 ||
413 die "Could not rewrite $ref"
414 ;;
415 esac
0ea29cce
EK
416 git update-ref -m "filter-branch: backup" "$orig_namespace$ref" $sha1 ||
417 exit
dfd05e38
JS
418done < "$tempdir"/heads
419
420# TODO: This should possibly go, with the semantics that all positive given
421# refs are updated, and their original heads stored in refs/original/
422# Filter tags
6f6826c5
JS
423
424if [ "$filter_tag_name" ]; then
5be60078 425 git for-each-ref --format='%(objectname) %(objecttype) %(refname)' refs/tags |
6f6826c5
JS
426 while read sha1 type ref; do
427 ref="${ref#refs/tags/}"
428 # XXX: Rewrite tagged trees as well?
429 if [ "$type" != "commit" -a "$type" != "tag" ]; then
430 continue;
431 fi
432
433 if [ "$type" = "tag" ]; then
434 # Dereference to a commit
435 sha1t="$sha1"
7bd93c1c 436 sha1="$(git rev-parse -q "$sha1"^{commit})" || continue
6f6826c5
JS
437 fi
438
439 [ -f "../map/$sha1" ] || continue
440 new_sha1="$(cat "../map/$sha1")"
3addc94a
JS
441 GIT_COMMIT="$sha1"
442 export GIT_COMMIT
8c1ce0f4
JS
443 new_ref="$(echo "$ref" | eval "$filter_tag_name")" ||
444 die "tag name filter failed: $filter_tag_name"
6f6826c5
JS
445
446 echo "$ref -> $new_ref ($sha1 -> $new_sha1)"
447
448 if [ "$type" = "tag" ]; then
a9da1663
JS
449 new_sha1=$( ( printf 'object %s\ntype commit\ntag %s\n' \
450 "$new_sha1" "$new_ref"
451 git cat-file tag "$ref" |
1bf6551e 452 sed -n \
9524cf29 453 -e '1,/^$/{
a9da1663
JS
454 /^object /d
455 /^type /d
456 /^tag /d
9524cf29 457 }' \
1bf6551e 458 -e '/^-----BEGIN PGP SIGNATURE-----/q' \
a9da1663 459 -e 'p' ) |
1bf6551e
BC
460 git mktag) ||
461 die "Could not create new tag object for $ref"
462 if git cat-file tag "$ref" | \
e1622bfc 463 sane_grep '^-----BEGIN PGP SIGNATURE-----' >/dev/null 2>&1
1bf6551e
BC
464 then
465 warn "gpg signature stripped from tag object $sha1t"
466 fi
6f6826c5
JS
467 fi
468
af580e9c
JS
469 git update-ref "refs/tags/$new_ref" "$new_sha1" ||
470 die "Could not write tag $new_ref"
6f6826c5
JS
471 done
472fi
473
97276019 474cd "$orig_dir"
6f6826c5 475rm -rf "$tempdir"
6f6826c5 476
def16e71
BC
477trap - 0
478
9273b562
EK
479unset GIT_DIR GIT_WORK_TREE GIT_INDEX_FILE
480test -z "$ORIG_GIT_DIR" || {
481 GIT_DIR="$ORIG_GIT_DIR" && export GIT_DIR
482}
483test -z "$ORIG_GIT_WORK_TREE" || {
484 GIT_WORK_TREE="$ORIG_GIT_WORK_TREE" &&
485 export GIT_WORK_TREE
486}
487test -z "$ORIG_GIT_INDEX_FILE" || {
488 GIT_INDEX_FILE="$ORIG_GIT_INDEX_FILE" &&
489 export GIT_INDEX_FILE
490}
491
a4661b01 492if [ "$(is_bare_repository)" = false ]; then
0ea29cce 493 git read-tree -u -m HEAD || exit
a4661b01 494fi
46eb449c 495
0ea29cce 496exit 0